
/****** Object:  StoredProcedure [dbo].[SP_COMMON_GR_MANIFEST_LOG]    Script Date: 30/04/2021 17:07:50 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author		:	FID.Ridwan
-- Create date	:	17-Apr-2021
-- Description	:	Common for insert update manifest detail
-- Update		: 
-- =============================================
ALTER PROCEDURE [dbo].[SP_COMMON_GR_MANIFEST_LOG] @USER_ID VARCHAR(20)
	,@R_MANIFEST_NO VARCHAR(100)
	,@R_PART_NO VARCHAR(100)
	,@R_TYPE INT
	,@R_MESSAGE VARCHAR(100)
	/*
		Type:
			 1 -> PAD_DOCK_CODE
			 2 -> PCD_MATERIAL_MASTER
			 3 -> PUD_PO
			 4 -> PUD_MATERIAL_PRICE
			 5 -> PUD_SOURCE_LIST
			 6 -> PUD_SUPPLIER_MASTER
			 7 -> ISTD_SYSTEM
	*/
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	DECLARE @query VARCHAR(MAX)

	BEGIN TRY
		MERGE TB_R_DAILY_ORDER_MANIFEST_DETAIL AS [TARGET]
		USING (
			SELECT A.MANIFEST_NO
				,B.ITEM_NO
				,B.RCV_PLANT_CD
				,B.DOCK_CD
				,B.PART_NO
				,B.PART_NAME
				,B.ORDER_QTY
				,B.RECEIVED_STATUS
				,@USER_ID CREATED_BY
				,GETDATE() CREATED_DT
			FROM TB_R_DAILY_ORDER_MANIFEST A
			JOIN TB_R_DAILY_ORDER_PART B ON A.MANIFEST_NO = B.MANIFEST_NO
			WHERE A.MANIFEST_NO = @R_MANIFEST_NO
				AND LEFT(B.PART_NO, 10) = LEFT(@R_PART_NO, 10)
			) AS [SOURCE]
			ON [SOURCE].MANIFEST_NO = [TARGET].MANIFEST_NO
				AND [SOURCE].ITEM_NO = [TARGET].ITEM_NO
				AND [SOURCE].PART_NO = [TARGET].PART_NO
		WHEN MATCHED
			THEN
				UPDATE
				SET [TARGET].PAD_DOCK_CODE = (CASE WHEN @R_TYPE = 1 THEN @R_MESSAGE ELSE [TARGET].PAD_DOCK_CODE END)
					,[TARGET].PCD_MATERIAL_MASTER = (CASE WHEN @R_TYPE = 2 THEN @R_MESSAGE ELSE [TARGET].PCD_MATERIAL_MASTER END)
					,[TARGET].PUD_PO = (CASE WHEN @R_TYPE = 3 THEN @R_MESSAGE ELSE [TARGET].PUD_PO END)
					,[TARGET].PUD_MATERIAL_PRICE = (CASE WHEN @R_TYPE = 4 THEN @R_MESSAGE ELSE [TARGET].PUD_MATERIAL_PRICE END)
					,[TARGET].PUD_SOURCE_LIST = (CASE WHEN @R_TYPE = 5 THEN @R_MESSAGE ELSE [TARGET].PUD_SOURCE_LIST END)
					,[TARGET].PUD_SUPPLIER_MASTER = (CASE WHEN @R_TYPE = 6 THEN @R_MESSAGE ELSE [TARGET].PUD_SUPPLIER_MASTER END)
					,[TARGET].ISTD_SYSTEM = (CASE WHEN @R_TYPE = 7 THEN @R_MESSAGE ELSE [TARGET].ISTD_SYSTEM END)
					,[TARGET].CHANGED_BY = [SOURCE].CREATED_BY
					,[TARGET].CHANGED_DT = [SOURCE].CREATED_DT
		WHEN NOT MATCHED
			THEN
				INSERT (
					MANIFEST_NO
					,ITEM_NO
					,RCV_PLANT_CD
					,DOCK_CD
					,PART_NO
					,PART_NAME
					,ORDER_QTY
					,RECEIVED_STATUS
					,CREATED_BY
					,CREATED_DT
					,PAD_DOCK_CODE
					,PCD_MATERIAL_MASTER
					,PUD_PO
					,PUD_MATERIAL_PRICE
					,PUD_SOURCE_LIST
					,PUD_SUPPLIER_MASTER
					,ISTD_SYSTEM
					)
				VALUES (
					[SOURCE].MANIFEST_NO
					,[SOURCE].ITEM_NO
					,[SOURCE].RCV_PLANT_CD
					,[SOURCE].DOCK_CD
					,[SOURCE].PART_NO
					,[SOURCE].PART_NAME
					,[SOURCE].ORDER_QTY
					,[SOURCE].RECEIVED_STATUS
					,[SOURCE].CREATED_BY
					,[SOURCE].CREATED_DT
					,(CASE WHEN @R_TYPE = 1 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 2 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 3 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 4 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 5 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 6 THEN @R_MESSAGE ELSE NULL END)
					,(CASE WHEN @R_TYPE = 7 THEN @R_MESSAGE ELSE NULL END)
					);
	END TRY

	BEGIN CATCH
	END CATCH
END
